
def prepare(data):
    infile, tmpfile = data
    
    # try to allocate enough for output

    from utils import allocate_space

    allocate_space(tmpfile + '.mrc', 2*1024*1024*1024) # 2G

def get_command(data):
    infile, tmpfile = data

    from utils import get_conf
    conf = get_conf(infile)

    command = ['clip', 'unpack']
    command += ['-D', conf['defects']]
    if (not 'rotategain' in conf) or conf['rotategain']:
        command += ['-R', '1']
    command += [infile + '.tif']
    command += [conf['gain']]
    command += [tmpfile + '.mrc']

    return command
