
def log(text):
    import datetime
    print (str(datetime.datetime.now()) + ': ' + text)

# loads configuration relative to a work filename
def get_conf(filename):
    import os

    basedir = os.path.dirname(filename)
    
    if not basedir:
        basedir = '.'
    conffile = basedir + '/autoprocess-params.yaml'
    
    try:
        import yaml
        stream = open(conffile, 'r')
        conf = yaml.load(stream)
    except Exception as e:
        log ("Can't load autoprocess config: %s" % e)
        return {}

    return conf

def check_space_available(filename, space):
    import os

    statvfs = os.statvfs(os.path.dirname(filename))

    # space available to regular users
    avail = statvfs.f_frsize * statvfs.f_bavail

    return avail > (space * 8) # quick dirty hack! to avoid sync pbs

class RetryException(Exception):
    pass

def allocate_space(filename, space):
    i = 0
    while not check_space_available(filename, space):
        from time import sleep
        sleep(30)
        i += 1
        if i > 5:
            raise RetryException

    # this is not atomic, I know but we will cross the fingers
    #import os
    #fd =  os.open(filename, os.O_CREAT | os.O_RDWR)
    #os.posix_fallocate(fd, 0, space)
    #os.close(fd)
