#!/bin/bash

DIR="$1"
EMAIL="$2"
DELAY=${3:-5}
EXT='tif'

# define usefull die func
die() { echo "$@" 1>&2 ; exit 1; }

# check argument count
[ $# -ge 2 -a $# -le 3 ] || die "Usage: $(basename $0) dir email [delay]"

# check directory
[ -d "$DIR" ]   || die "Input '$IN' not a directory"

cd "$DIR"

coproc DOG {
  echo $(date +'%D %T') "Hello, I'm the watchdog and I need some $EXT file in '$DIR' every $DELAY seconds or I will complain and send an email to $EMAIL!" >&2
  # read with a timeout
  while read -t $DELAY line; do
    if [ $line = "food" ]; then
      echo $(date +'%D %T') "Okay, got food" >&2
    fi
  done
  # if we go out of the loop then it's too late!
  echo $(date +'%D %T') "Too late, sending an email." >&2
  mail -s "Titan produced no $EXT file for $DELAY seconds!" -r 'Titan <titan@titan.igbmc.u-strasbg.fr>' "$EMAIL" <<< ""
  kill $$
}

# build the loop this way: putting the while at the end will spawn a subshell
while read line; do
  # feed the dog
  echo "Feeding the dog since $line appeared"
  echo "food" >&${DOG[1]}
done < <(inotifywait -q -r -m . -e close_write -e moved_to --format '%w%f' | grep --line-buffered ".*$EXT$")
